// [License]
// The Ariba-Underlay Copyright
//
// Copyright (c) 2008-2009, Institute of Telematics, Universität Karlsruhe (TH)
//
// Institute of Telematics
// Universität Karlsruhe (TH)
// Zirkel 2, 76128 Karlsruhe
// Germany
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// 1. Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE INSTITUTE OF TELEMATICS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE ARIBA PROJECT OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation
// are those of the authors and should not be interpreted as representing
// official policies, either expressed or implied, of the Institute of
// Telematics.
// [License]

#ifndef __OMNET_NETWORK_PROTOCOL_H
#define __OMNET_NETWORK_PROTOCOL_H

#include "ariba/communication/modules/network/ip/IPv4Locator.h"
#include "ariba/communication/modules/network/NetworkProtocol.h"
#include "ariba/communication/modules/network/NetworkLocator.h"
#include <iostream>
#include <omnetpp.h>
#include <InterfaceTable.h>
#include <IPv4InterfaceData.h>
#include <IPAddress.h>

using std::cout;
using ariba::communication::IPv4Locator;
using ariba::communication::NetworkProtocol;
using ariba::communication::NetworkLocator;

namespace ariba {
namespace communication {

class OmnetNetworkProtocol : public NetworkProtocol{
public:
	OmnetNetworkProtocol( cSimpleModule* _module );
	virtual ~OmnetNetworkProtocol();

	virtual const NetworkProtocol::NetworkLocatorSet getAddresses() const;

protected:
	cSimpleModule* module;
};

}} // namespace ariba, communication, internal

#endif // __OMNET_NETWORK_PROTOCOL_H
